***********************************************
*                fax.prg                      *
*          Programm zum Faxen                 *
*        Arztpraxis Dr. Neumann               *
*           Stand: 20.11.2011                 *
***********************************************
function main()
public rueck,cdirorg
cdirorg := dirname()
set color to W+/B, R/BG,,, R/BG
set confirm on 
set cursor on
REQUEST DBFCDX
REQUEST DBFFPT
REQUEST HB_CODEPAGE_DEWIN
HB_SETTERMCP("DEWIN")
RDDSETDEFAULT("DBFCDX")
select 1
use fax alias fax
index on fax->Name to fax
do browse
return .t.
********************
function drucken()
local adir,cscreen,njn,nfaxweg,cname,cfaxn
local cini,i,imax,cLine,fehlertxt
local faxnum,ccopybef,cfaxbef

nfaxweg := fax->weg
cname := fax->name
cfaxn := fax->fax

cscreen:= savescreen()
if empty(cfaxn)
fsay("keine Fax-Nummer eingetragen!")
return .t.
endif
adir := Directory( "*.log" )
for i:=1 to len(adir)
delete file ( adir[i,1] )
next
delete file "lpt.ps"
cls
@ 10,10 say "Faxversand luft"
faxnum := strtran(cfaxn,"/","")
faxnum := strtran(faxnum," ","")
faxnum := alltrim(faxnum)
*
cini := memoread("fax.ini")

imax := mlcount( cini )
for i:=1 to imax
   cLine := memoline(cini,,i,,)
   if !empty(cLine)
   if left(cLine,8) = "ccopyps"+alltrim(str(nfaxweg))
     ccopybef := alltrim(substr(cLine,at("=",cLine)+1))
   endif
   if left(cLine,8) = "cfaxbef"+alltrim(str(nfaxweg))
     cLine := alltrim(cLine)
     cLine := strtran(cLine,'"',"")
     cfaxbef := substr(cLine,at("=",cLine)+1)+faxnum+" /"+curdir()+"/lpt.ps"
   endif
   endif
next

run(ccopybef)
if !file("lpt.ps")
fsay("keine auszudruckende Datei gefunden!")
cls
restscreen(,,,,cscreen)
return .t.
endif
njn := fwait(cname)
if njn==1
cls
@ 10,10 say "Faxversand luft"

fehlertxt := ""
run(cfaxbef+" 2> faxfehler.txt")
fehlertxt := memoread("faxfehler.txt")
if !empty(fehlertxt)
cls
? fehlertxt
wait
else
cls
restscreen(,,,,cscreen)
fsay("Fax erfolgreich versendet")
adir := Directory( "lpt.*" )
for i:=1 to len(adir)
delete file ( adir[i,1] )
next
endif
*
endif //njn==1
*
cls
restscreen(,,,,cscreen)
return .t.
******************
function browse()
local acols:= { "Name", "Vorname", "Fax", "Weg" }
memvar getlist
clear gets
Clear screen
go top

declare FELDER[fcount()]
afields(FELDER)

@ 21,10 SAY "ndern: [RETURN] Programm verlassen: Escape"
@ 22,10 SAY "Suchen: F2       Datenbank neu aufbauen: F3"
@ 23,10 SAY "Faxen:  F8       Druckdatei lschen: F5"
@ 24,10 SAY "Faxnummer direkt eingeben: F7"

DBEDIT(2,0,19,79,acols,"editieren",,,,)
return .t.

*** Dateibearbeitung mit Funktion editieren ***

function editieren()
local csuch,Zeile,Reihe,rueck,cdir,nn1,i
local name,fax,Infield,cscreen,cini,cfaxeingabe
local cline,imax,ccopybef,capwpfad
memvar getlist,FELDER
Parameters Modus, Initial

Zeile=COL()
Reihe=ROW()
rueck=1
modus=0

Do case
*** Escape = Verlassen
        Case Lastkey()=27
          close all
          quit

*** Bearbeiten eines Feldes mit RETURN ***
	Case Lastkey()=13
		set cursor on
		Infield = FELDER[Initial]
		@ Reihe, Zeile GET &Infield 
		Read
		set cursor off

*** Faxdatei lschen mit F5 ***
	Case LASTKEY()=-4
	      cdir := "/"+curdir()+"/"  
              run("rm -f "+cdir+"lpt.ps")

*** Brief an Nummer des Datensatzes faxen mit F8 ***
	Case Lastkey()=-7
		drucken()

*** Datensatz suchen mit F2 ***
	Case Lastkey()=-1
		set cursor on
		csuch = space(15)
		@ 0,5 say "Welchen Namen suchen? " get csuch
		read
		go top
		dbseek( csuch,.t. )
		@ 0,0 clear to 0,50

*** Datenbank neu aufbauen mit F3 ***
  Case Lastkey()=-2
    cscreen:=savescreen()
    cdir := "/"+curdir()+"/"
    cini := memoread("fax.ini")
    imax := mlcount( cini )
    for i:=1 to imax
       cLine := memoline(cini,,i,,)
       if !empty(cLine)
       if left(cLine,4) = "capwpfad"
         capwpfad := alltrim(substr(cLine,at("=",cLine)+1))
       endif
       endif
    next
    run("scp "+capwpfad+"/adr.dbf "+cdir)
    run("scp "+capwpfad+"/adr.fpt "+cdir)
    if file(cdir+"adr.dbf")
                zap
                select 2
                use adr alias adr
                nn1:= lastrec()
                for i:=1 to nn1
                  select 2
                  go i
                  if !empty(name) .and. !(empty(fax))
                    select 1
                    append blank
                    replace fax->name with left(adr->name,20)
                    replace fax->vorname with left(adr->vorname,20)
                    replace fax->fax with adr->fax
                    replace fax->weg with 1
                  endif
                next
                select 2
                close adr
                select 1
                restscreen(,,,,cscreen)
                go top
                fsay("Datenbank erfolgreich aufgebaut")
      else
      fsay("Datenbank-Aufbau gescheitert")
      endif

*** Faxnummer von Hand eingeben F7 ***
  case Lastkey()=-6
    cscreen:= savescreen()
    cdir := "/"+curdir()+"/"
    run "rm -f "+cdir+"lpt.ps"
    cini := memoread("fax.ini")
    imax := mlcount( cini )
    for i:=1 to imax
       cLine := memoline(cini,,i,,)
       if !empty(cLine)
       if left(cLine,8) = "ccopyeingabe"
	 ccopybef := alltrim(substr(cLine,at("=",cLine)+1))
       endif
       if left(cLine,11) = "cfaxeingabe"
	 cLine := alltrim(cLine)
	 cLine := strtran(cLine,'"',"")
	 cfaxeingabe := substr(cLine,at("=",cLine)+1)+" /"+curdir()+"/lpt.ps"
       endif
       endif
    next

    run(ccopybef)
    if !file("lpt.ps")
      fsay("keine auszudruckende Datei gefunden!")
      cls
      restscreen(,,,,cscreen)
    else
    run(cfaxeingabe)
    restscreen(,,,,cscreen)
    endif

endcase
 
*** Programm verlassen ber den Rckgabewert ***
RETURN (Rueck)
***********************************
function verlassen()
close databases
clear screen
quit
return .t.
********************************
function fsay(ctext)
local cscreen,vcursor
cscreen:= savescreen()
cls
@ 10,10 say ctext
vcursor = setcursor(1,readinsert())
inkey(0)
setcursor(vcursor,readinsert())
restscreen(,,,,cscreen)
return .t.
********************************
function fwait(cname)
local cscreen1,njn
cscreen1 = savescreen()
cls
setcursor(1)
@ 10,10 say "Fax an "+alltrim(cname)+" versenden? J/N"
inkey(0)
cls
restscreen(,,,,cscreen1)
do case
case lastkey() = 106 .or. lastkey() = 74  //j, J
  njn = 1
otherwise  //nein
  njn = 0
endcase
return njn
********************************
procedure fdummy()





